/*

	Project					InTimePro 
	Version			 		1.1.0
	Author					Stephan M. Sprenger
	Company					PROSONIQ PRODUCTS SOFTWARE GmbH
	Country					Germany
	Type					Header File
	Last changed			28.05.96, 22:39
	Bugs					Q_AUTO is not supported in this release
	Tabsize					4

*/


/* defines for InTimePro routines */
						
#define ITPINIT			0		/* first call to InTimePro() initializes static variables and LUTables */
#define ITPSTEP			1		/* estimates location of next segment that is of interest */ 
#define ITPPROCESS		2		/* analyzes and derives reconstruction parameters from the audio material */
#define ITPFLUSH		3		/* generates and composes the processed output signal */

#define TIMEBASE		0		/* time scaling */
#define PITCH			1		/* pitch scaling */

#define Q_POOR			0		/* lowest quality - fastest processing */
#define Q_BETTER		1		/* better quality - slightly slower processing */
#define Q_GOOD			2		/* default quality - optimum trade-off */
#define Q_EXCELL		3		/* highest quality - quite slow */
#define Q_AUTO			4		/* sets quality according to the audio material (not supported in 1.0.0) */

#define ILEN 			1024	/* basic block size for all InTimePro read and write operations */


/* function prototype */

long InTimePro(short mode, long *iodata, long *writeFrames, long startFrame, float percent, \
		short scale, short quality, short adjust);

