/*
	devlib: Header file for LIBcvt.c.
	
	source:  LIBcvt.h
	started: December 13, 1993.
	version:
		November 7, 1995.
			Added cvt_l2s, cvt_ul2s and cvt_hex2s.
			Added cvt_frac.
		January 7, 1994.
*/

#ifndef LIBcvt_h_
#define LIBcvt_h_

#pragma once

#ifndef CVT_BUF_SIZE
	#define CVT_BUF_SIZE 200
#endif

	/* safe: no buffer needed. */

int		cvt_1000percent	(long n, ulong tot);
char *	cvt_blanks		(int n);
char *	cvt_bool		(bool b);
char *	cvt_short_fn	(char * file_name);
void	cvt_test		(void);

	/* Unsafe without a buffer of a specified size. */

char *	cvt_cat2		(char * buf, int buf_len, char *s1, char *s2);
char *	cvt_cat3		(char * buf, int buf_len, char *s1, char *s2, char *s3);
char *	cvt_char		(char * buf, int buf_len, int c);
char *	cvt_date		(char * buf, int buf_len, bool quote_flag);
char *	cvt_double		(char * buf, int buf_len, double d);
char *	cvt_file_error	(char * buf, int buf_len, int OSErrCode);
char *	cvt_frac		(char * buffer, int buf_size, long a1, long a2);
char *	cvt_hex			(char * buf, int buf_len, long hex);
short	cvt_hex2s 		(char * buf, ulong hex);
char *	cvt_int			(char * buf, int buf_len, int i);
char *	cvt_long		(char * buf, int buf_len, long a);
short	cvt_l2s 		(char * buf, long val);
char *	cvt_paren		(char * buf, int buf_len, char * s);
char *	cvt_percent		(char * buf, int buf_len, long n, ulong tot);
char *	cvt_pstring		(char * buf, int buf_len, pstring p);
char *	cvt_quote		(char * buf, int buf_len, char * p);
char *	cvt_ptr			(char * buf, int buf_len, void * p);
char *	cvt_time		(char * buf, int buf_len, bool quote_flag);
char *	cvt_trunc		(char * buf, int buf_len, char * p, int length);
char *	cvt_uint 		(char * buf, int buf_len, uint ui);
char *	cvt_ulong		(char * buf, int buf_len, ulong ul);
short	cvt_ul2s 		(char * buf, ulong val);

#endif /* LIBcvt_h_ */
