/*
	devlib: header file for error stream output routines.
	
	source:  LIBes.h.
	started: December 13, 1993.
	version:
		February 9, 1996.
			Added support for C++.
		November 7, 1995.
			Made ejustify global for use by LIBfloat.c.
		December 4, 1994.
			Added ebell.
		July 17, 1994.
			Added ecblanks.
		June 2, 1994.
			Added es2os_flag.
		January 7, 1994.
*/

#ifndef LIBes_h_
#define LIBes_h_

#pragma once

#ifdef __cplusplus	// 2/9/96
extern "C" {
#endif

/*
	Globals owned by this module.
*/
extern int es2os_flag;	/* TRUE: all call to es stream go to os stream. */

/*
	Function prototypes.
*/
void	eangle		(char *c);
void	ebell		(void);
void 	ebool		(bool b);
void	eblank		(void);
void	eblanks		(int n);
void	ebracket	(char *s);
void	ecblanks	(short n);
void	echar		(int c);
void	ecnl		(void);
void	ecnls		(short requested_newlines);
void	ecurly		(char *s);
void	ecs			(void);
void	edouble		(double d);
void	efrac		(long a1, long a2);
void	ehex		(long l);
void	ehexchar	(long l);
void	eint		(int i);
void	ejustify	(char * buffer, int length, int field_length);
void	elong		(long l);
void	ehex		(long l);
void	elp			(void);
void	emsec		(long ticks);
void	enl			(void);

void	epadbool	(bool b, int field);
void	epadchar	(char c, int field);
void	epaddouble	(double d, int field);
void	epadfrac	(long a1, long a2, int field);
void	epadhex		(long l, int field);
void	epadint		(int i,  int field);
void	epadlen		(int item_length, int field);
void	epadlong	(long l,   int field);
void	epadmsec	(long ticks, int field);
void	epadparen	(char * s, int field);
void	epadparenlong(long a, int field);
void	epadptr		(void * p, int field);
void	epads		(char * s, int field);
void	epaduint	(uint ui, int field);
void	epadulong	(ulong ul, int field);

void	eparen		(char * s);
void	epercent	(long n, ulong tot);
void	eplural		(long n);
void	eptr		(void * p);
void	epstring	(char * p);
void	equote		(char *s);
void	eret		(void);
void	erpnl		(void);
void	es			(char * s);
void	es_assert_failed	(char * condition, int line, char * file);
void	es_internal_err		(char * condition, int line, char * file);
void	etab		(void);
void	etabs		(int tab_count);
void	etrunc		(char * p, int length);
void	euint 		(uint ui);
void	eulong		(ulong ul);

long	ticks2msec	(long ticks);

#ifdef __cplusplus	// 2/9/96
}
#endif

#endif /* LIBes_h_ */
