/*
	devlib: template for the application-specific version of this file.
	
	source:  LIBlib.c
	started: January 7, 1994.
	version:
		February 9, 1996.
			Changed lib_arg_file_prompt to lib_log_file_prompt.
		September 26, 1995
			err_begin must return TRUE by default.
			Added lib_log_file_name.
*/

#include <LIBlib.h>

	/* Define variables used by devlib. */
	
pstring	lib_about_title		= "\pAbout XX";			/* Must be a pascal string. */
char *	lib_log_file_prompt = "XX log file...";		/* Prompt for file name. */

char *	lib_dialog_version	= "XX version 1.0:\r\rCopyright  1996 by Edward K. Ream.";

char *	lib_log_window_name	= "XX log";			/* The name of log window. */
char *	lib_program_name	= "XX";				/* The name of the program. */

#if defined(THINK_C) || defined(SYMANTEC_C) || defined(__MWERKS__)
	char *	lib_arg_file_name = "XXargs";	/* The name of the argument file. */
	char *	lib_log_file_name = "XXlog";	/* The name of the log file. */
#elif defined(applec)
	char *	lib_arg_file_name = "XX MPW args";
	char *	lib_log_file_name = "XX MPW log";
#else
	char *	lib_arg_file_name = "XXargs.txt";
	char *	lib_log_file_name = "XXlog.txt";
#endif

char *	lib_version = "XX version 1.0";

/*
	The following functions should be defined in appropriate places in the application
	as indicated.
	
	What follows are minimal defintions that should be "over-ridden"
*/

/* XXend.c: close all application files. */
void
end_close_all(void)
{
	FTAG("end_close_all");
	STATB(ftag);
	STATX(ftag);
}

/* XXerr.c: start an error message. */
bool
err_begin(void)
{
	FTAG("err_begin");
	STATB(ftag);
	ecnls(2);
	STATX(ftag);
	return TRUE;
}

/* XXerr.c: print the context, if any, of an error. */
void
err_context(void)
{
	FTAG("err_context");
	STATB(ftag);
	STATX(ftag);
}

/* XXes.c or XXerr.c: print the start of an ASSERT failed message. */
void es_assert_failed(char * condition, int line, char * file)
{
	FTAG("es_assert_failed");
	STATB(ftag);
	STATX(ftag);
}

/* XXes.c or XXerr.c: print the start of a PERM_ASSERT_TRACE failed message. */
void es_internal_err(char * condition, int line, char * file)
{
	FTAG("es_internal_error");
	STATB(ftag);
	STATX(ftag);
}

/* XXerr.c: start a fatal error message. */
void
fatal_begin(void)
{
	FTAG("err_begin");
	STATB(ftag);
	STATX(ftag);
}

/* XXerr.c: end a fatal error message. */
void
fatal_end(void)
{
	FTAG("err_begin");
	STATB(ftag);
	STATX(ftag);
}

/* XXmain.c: Print any end-of-application reports. */
void
main_quit(void)
{
	FTAG("main_quit");
	STATB(ftag);
	STATX(ftag);
}
