/*
	devlib:  master header file.
	
	source:  LIBlib.h
	started: January 7, 1994.
	version:
		February 9, 1996.
			Added support for C++.
		September 26, 1995.
			Added lib_log_file_name to fix a bug in the Sherlock dialog.
		July 11, 1994.
			Added lib_stderr_flag.
		June 19, 1994.
*/

#ifndef LIBlib_h_
#define LIBlib_h_

#pragma once

#ifdef __cplusplus	// 2/9/96
extern "C" {
#endif

#ifdef PRODUCTION
	#undef SHERLOCK
#else
	#define SHERLOCK
#endif

#include <LIBtypes.h>	/* Must come first. */
#include <sl.h>			/* Must come second. */
#include <LIBcvt.h>
#include <LIBdebug.h>
#include <LIBes.h>

/*
	Define standard abbreviations.
*/
#define str_eq(a,b) (strcmp(a,b)==0)

#ifndef max
	#define max(a,b) (((a) > (b)) ? (a) : (b))
#endif

#ifndef min
	#define min(a,b) (((a) < (b)) ? (a) : (b))
#endif

#ifndef TRUE
	#define TRUE 1
#endif

#ifndef FALSE
	#define FALSE 0
#endif

/* 
	Define function prototypes for routines called by the library that
	must be defined outside the library.
*/

void end_close_all	(void);

bool err_begin		(void);
void err_context	(void);

void es_assert_failed	(char * condition, int line, char * file);
void es_internal_err	(char * condition, int line, char * file);

void fatal_begin	(void);
void fatal_end		(void);

void main_quit		(void);

/*
	Define variables used by the library that must be defined outside the library.
*/
extern pstring	lib_about_title;		/* Must be a pascal string. */
extern char *	lib_arg_file_name;		/* The name of the argument file. */
extern char *	lib_log_file_name;		/* The name of the argument file. */
extern char *	lib_log_file_prompt;	/* Prompt for file name. */
extern char *	lib_log_window_name;	/* The name of log window. */
extern bool		lib_modem_flag;			/* 0/1 send output to modem/printer port. */
extern char *	lib_program_name;		/* The name of the program. */
extern bool		lib_serial_flag; 		/* TRUE: S-record output goes to serial port. */
extern bool		lib_stderr_flag;		/* TRUE: send log output to stderr on the Mac. */
extern char *	lib_version;			/* Version for signon message. */

#ifdef __cplusplus	// 2/9/96
}
#endif

#endif /* LIBlib_h_ */
