/*
	devlib: header file for LIBos.c.
	
	source:  LIBos.h
	started: December 13, 1993.
	version:
		July 17, 1994.
			Added ocblanks.
		June 2, 1994.
			Added ohex, oint, olong, opadptr and optr.
		May 24, 1994.
			Added ocnl and ocnls.
			Added opads.
		May 5, 1994.
			Added out_bytes_offset variable.
		April 21, 1994.
			Added ofloat routine.
		January 7, 1994.
*/

#ifndef LIBos_h_
#define LIBos_h_

#pragma once

#include <LIBio.h>

	/* Routines that write to a binary file. */
	
void out_bytes(register char * byte_ptr, register ulong byte_count, char * dtag);

	/* Routines that write to a text file. */
	
void	oblank		(void);
void	oblanks		(int n);
void	ocblanks	(short n);
void	ochar		(int c);
void	ocnl		(void);
void	ocnls		(int requested_newlines);
void	ocs			(void);
void	ofloat		(char * p, int size);
void	ohex		(long hex);
void	oint		(int i);
void	olong		(long l);
void	onl			(void);
void	os			(char * s);
void	opadhex		(long l, int field);
void	opadlong	(long l, int field);
void	opadptr		(void * p, int field);
void	opads		(char * s, int field);
void	opaduint	(uint ui, int field);
void	opadulong	(ulong ul, int field);
void	optr		(void * p);
void	otab		(void);
void	otabs		(int tab_count);
void	ouint		(uint ui);
void	oulong		(ulong ul);

long	ticks2msec	(long ticks);

	/* Global variables. */
	
extern io_file *os_bytes_file;	/* The application binary output file. */
extern io_file *os_text_file;	/* The application text   output file. */

extern ulong out_bytes_offset;	/* The byte address for dumps in out_bytes. */

#endif /* LIBos_h_ */
