/*
	Header file for SDEL
	
	source:  sdel.h
	started: June 8, 1991.
	version: April 2, 1996.
*/

#ifndef sdel_h_
#define sdel_h_

#pragma once

#include <LIBlib.h>

	// Abbreviations

#define ochar(c) fputc(c, out_file)
#define os(s)    fputs(s, out_file);
#define onl(s)   fputc('\n', out_file)

#define warning(stat) es("warning line: "); eint(line); stat; ecnl()

#define str_eq(a,b) (strcmp(a,b)==0)
#define ishex(c) ((c>='0'&&c<='9') || (c>='a'&&c<='f') || (c>='A'&&c<='F'))
#define isid1(c) (isalpha(c) || c=='_')
#define isid2(c) (isalpha(c) || isdigit(c) || c=='_')

	// Public globals

extern char * in_file_name;		/* Input file name. */
extern char * out_file_name;	/* Output file name. */
extern char * syn_file_name;	/* Synonym file name. */

extern FILE * in_file;	/* Input file. */
extern FILE * out_file;	/* Output file. */
extern FILE * syn_file;	/* Synonym file. */

extern long line;	/* Current line number. */
extern short ch;	/* The _next_ character. */

extern char * r_void; 		/* Default spellings... */
extern char * s_disable;
extern char * s_name;
extern char * rmn_tab [];
extern char *  mn_tab [];

	// Public prototypes

void get_id		(char * buffer);
void main_quit	(void);
void next_ch 	(void);
void skip_bl	(void);

#endif /* sdel_h_ */
