/*
	SDEL: Application-specific production error routines.
	
	source:  sdel_err.c
	started: April 2, 1996.
	version: April 2, 1996.
*/

#include "sdel.h"

#include <LIBend.h>
#include <Dialogs.h>

/// Public globals

short err_count = 0;

/// Private globals.

static bool in_fatal = FALSE;

bool
err_begin(void)
{
	ecnls(2); es("error: ");
	es("line "); eint(line); es(": ");
	err_count++;
	return TRUE;
}

void
err_context(void)
{}

void
fatal_begin(void)
{
	ecnls(2);
	es("Oh Dear...There is something wrong me\n");
	es("in: "); es(current_ftag);
	es(" called from "); es(caller_ftag);
	es(" called from "); es(caller2_ftag);
	enl();

	if (in_fatal) {
		es("Encountered a second fatal error...aborting now!\n");
		end_abort();
	}
	in_fatal = TRUE;
}

void
fatal_end(void)
{
	ecnls(2);
	end_abort();
}
