/*
	SDIF: initialization code.

	Source:  SDIF_init.c
	Started: March 31, 1996.
	Version: April 6, 1996.
*/

/* include these *before* Sherlock is included. */
#include <Dialogs.h>
#include <Fonts.h>
#include <Menus.h>
#include <Quickdraw.h>
#include <OSEvents.h>
#include <Windows.h>
#include <LIBdialog.h>
#include <mac_gui.h>

#include "sdif.h"
#include "sdif_arg.h"
#include "sdif_init.h"

#include <LIBcmnd.h>
#include <LIBend.h>
#include <LIBenv.h>
#include <LIBlog.h>
#include <LIBobj.h>

// Private prototypes.

static void	event_call_back	(void);
static void init_windows 	(void);

/*
	Initialize the environment and Sherlock and all modules.
*/
void
init_all(void)
{
	FTAG("init_all");
	
	/// Initialize the ToolBox
	
		/* Grow the heap to its maximum size. */
		MaxApplZone();	
		
		/* Create more master pointers. */
		MoreMasters();		   		
		MoreMasters();		   		
		MoreMasters();		   		
		MoreMasters();		   
		MoreMasters();
		
		/* Initialize the ROM. */
		InitGraf( (Ptr) &(qd.thePort));
		InitFonts();
		InitWindows();
		InitMenus();
		TEInit();
		InitDialogs(0L);
	
		/* Flush previous events and change the cursor from a watch to an arrow. */
		FlushEvents(everyEvent,0);
		InitCursor();

	/// Initialize the Sherlock window.

		w_mac_init(
			FALSE,					/* Initialize the Macintosh ToolBox. */
			TRUE,					/* TRUE: output to Sherlock window. */
			"SDIF LOG",				/* Name of Sherlock window (if used). */
			TRUE,					/* TRUE: open Sherlock window. */
			TRUE,					/* TRUE: Insert standard menus. */
			TRUE,					/* TRUE: Insert Sherlock menu. */
			TRUE,					/* TRUE: Insert first item in apple menu. */
			(pstring) "\pAbout SDIF...",	/* Title of first item in apple menu. */
			&about_dialog,			/* CallBack routine for first apple item. */
			TRUE,					/* TRUE: Insert menus immediately. */
			&event_call_back,		/* Event callback routine. */
			NULL,					/* First user callback routine. */
			(pstring) "\p",			/* Name of first user menu item. */
			NULL,					/* Second user callback routine. */
			(pstring) "\p",			/* Name of second user menu item. */
			NULL,					/* Third user callback routine. */
			(pstring) "\p"			/* Name of third user menu item. */
		);

	/// Initialize Sherlock.
	
		SL_INIT();

	/// Process all arguments.
	{
		int argc = 0;
		char ** argv = NULL;

		init_args(&argc, &argv, lib_arg_file_name);
		SL_PARSE(argc, argv, "++", "--");
		
		/* Sherlock traces now in effect. */
		arg_do_argv(argc, argv);
	}

	STATB(ftag);

	/* Watch location 0.  This test catches *p = x where p is NULL. */
	SL_WATCH(0, 4, "loc 0");

	/* Sign on _after_ opening the log file. */
	ecnl(); es(lib_version); ecnl();
	
	init_windows();

	STATX(ftag);
}

static void
init_windows (void)
{
	w1.line = 1;
	w2.line = 1;
	w1.eof  = FALSE;
	w2.eof  = FALSE;
	w1.nlines = 0;
	w2.nlines = 0;
	w1.first  = 0;
	w2.first  = 0;
	w1.last   = 0;
	w2.last   = 0;

	{
		int i;
		for (i = 0; i < WINDOW_LINES; i++) {
			w1.index[i] = 0;
			w2.index[i] = 0;
		}
	}
}

/*
	"Call-back" routines for event processing when Sherlock outputs a line.
*/
static void
event_call_back(void)
{
	SL_DISABLE();

	if (w_applEvent(0) == FALSE) {
		main_quit();
	}
}
