/*
	SDIF: argument class.

	Source:  SDIF_arg.c
	Started: March 31, 1996.
	Version: April 2, 1996.
*/

#include "sdif.h"
#include "sdif_arg.h"

#include <LIBend.h>
#include <string.h>

// Public globals

bool b_flag = FALSE;
bool v_flag = FALSE;
bool s_flag = FALSE;

// Private prototypes

static void help (void);

/*
	Process command line arguments.
	This routine is not used if a modal dialog is used.
*/

void
arg_do_argv(int argc, char ** argv)
{
	char * arg;
	
	/* Make first test for correct command line. */
	if (argc == 2 && str_eq(argv[1], "-?")) {
		help();
		end_usage();
	}
	else if (argc < 3) {
		help();
		end_usage();
	}

	/* Process all the arguments on the command line. */
	argc--;
	argv++;
	while (argc-- > 0) {
		arg = *argv++;

		if (str_eq(arg, "-b")) {
			b_flag = TRUE;
		}
		else if (str_eq(arg, "-s")) {
			s_flag = TRUE;
		}
		else if (str_eq(arg, "-v")) {
			v_flag = TRUE;
		}
		else if (str_eq(arg, "-?")) {
			/* Ignore it. */
			;
		}
		else if (w1.name == NULL) {
			w1.name = arg;
		}
		else if (w2.name == NULL) {
			w2.name = arg;
		}
		else {
			es("Extra file argument: "); es(arg); enl();
			end_usage();
		}
	}

	/* Open the input files. */
	w1.file = fopen(w1.name, "r");
	if (w1.file == NULL) {
		es("Can not open "); es(w1.name); enl();
		end_usage();
	}
	w2.file = fopen(w2.name, "r");
	if (w2.file == NULL) {
		es("Can not open "); es(w2.name); enl();
		fclose(w2.file);
		end_usage();
	}
}

static void
help (void)
{
	ecnls(2);
	es("usage: SDIF in1(with macros) in2(without) [options]");
	ecnls(2);
	es("-b    Report inserted blank lines.\n");
	es("-s    Report detailed status of comparison.\n");
	es("-v    List all lines of in1 file.\n");
	es("-?    Print version number and exit.\n");
}

