/*
	SPP: header file for user arguments.
	
	source:  SPParg.h
	started: November 29, 1990
	version: March 17, 1996.
*/

#ifndef SPParg_h_
#define SPParg_h_

#pragma once

#include "SPPio.h"

/*
	Define the maximum file name size.
*/
#define MAX_FILE_NAME 300

/*
	User Flags.
*/
extern bool	exxx_flag;		/* TRUE: generate exxx() calls. */
extern bool ftag_flag;		/* TRUE: generate FTAG macro on entry. */

extern bool	insert_flag;	/* TRUE: insert #include "sl.h" */
extern bool	nest_flag;		/* TRUE: comments can nest. */
extern bool	usr_flag;		/* TRUE: use user output routines. */
extern bool usr2_flag;		/* TRUE: use user format routines. */
extern bool	tick_flag;		/* TRUE: use count statistics only. */
extern bool	slc_flag;		/* TRUE: allow single-line comments. */

/*
	The following flags are always left TRUE in the current version.
*/
extern bool	entry_flag;		/* TRUE: generate Sherlock macros on entry.	*/
extern bool	exit_flag;		/* TRUE: generate Sherlock macros on exit. */
extern bool	loop_flag;		/* TRUE: generate Sherlock macros in loops.	*/
extern bool return_flag;	/* TRUE: generate RETURN_XXX macros. */


/*
	Define buffers for communication between arg.c and arg_dialog.c.
	
	These buffers are used only when the the argument dialog is used.
	The buffers are allocated in arg_dialog.c.
	The size of these buffers is ARG_BUF_SIZE.
*/
#define ARG_BUF_SIZE 256

extern char * arg_def_buf;
extern char * arg_undef_buf;

/*
	Declare variables describing the input and output file paths.
	These are used to open files and to search for include paths.
*/
extern io_path *	arg_arg_path;
extern io_path *	arg_in_path;
extern io_path *	arg_out_path;
extern io_path *	arg_syn_path;
extern io_path *	arg_search_paths;
extern io_path *	arg_paths;

extern io_file *	arg_arg_file;

extern io_strm *	arg_in_strm;
extern io_strm *	arg_out_strm;

/*
	Function prototypes.
*/
void	arg_do_argv 		(int argc, char **argv,
								char * on_str, char * off_str);
bool	arg_init_again		(void);
void 	arg_show			(void);

#endif /* SPParg_h_ */
