/*
	SPP: header file for hold buffer module.
	
	source:  SPPhold.h
	started: February 14, 1991.
	version:
		March 22, 1996.
			Added copy_buf [] and copy_count.
*/

#ifndef SPPhold_h_
#define SPPhold_h_

#pragma once

/*
	White space and held output.
*/
#define MAX_HOLD		1000	/* Max length of holding buffer.	*/

extern int	hws_count;				/* Count of held white space.	*/
extern char	hws_buf [MAX_HOLD];		/* Held white space.			*/

extern int	lws_count;				/* Leading white space count.	*/
extern char	lws_buf [100];			/* Leading white space buffer.	*/

extern int	cnl_count;				/* Consecutive newline count.	*/
extern bool	hold_flag;				/* TRUE if holding characters.	*/

extern int	hold_ch;				/* TRUE if ch should be buffered. */

extern char	hold_buf [MAX_HOLD];	/* Held non-white space.	*/
extern int	hold_count;

extern char	copy_buf [MAX_HOLD];	/* Copy of return expression. */
extern int	copy_count;				/* Number of characters in copy_buf []. */
extern bool	copy_buf_flag;			/* True if copying characters. */

/*
	Function prototypes.
*/
void	hold_dump		(void);
void	hold_flush		(void);
void	hold_init_again	(void);
void	hold_kill		(void);
char *	hold_nldel		(void);

#endif /* SPPhold_h_ */
