/*
	SPP: header file for semantics module.
	
	source:  SPPsem.h
	started: February 14, 1991.
	version: March 21, 1996.
*/

#ifndef SPPsem_h_
#define SPPsem_h_

#pragma once

#include "SPPenum.h"

/*
	Function prototypes.
*/
bool	is_base		(en_tokens tok);
bool	is_type		(void);
bool	is_typedef	(char * id);

void	sd_dcl		(en_scope scope);
void	sd_end		(en_scope scope, en_tokens end_tok);
void	sd_fn_name	(char * name);
void	sd_func		(void);
void	sd_htype	(en_scope scope, en_tokens token);
void	sd_id		(en_scope scope, char * id);
void	sd_type		(en_scope scope, en_tokens token);
void	sd_typedef	(en_scope scope);

void	sem_init_again	(void);

void	sf_1body	(void);
void	sf_2body	(void);
void	sf_break	(void);
void	sf_default	(void);
void	sf_1do		(void);
void	sf_2do		(void);
void	sf_expr		(void);
void	sf_1for		(bool empty_control);
void	sf_2for		(void);
void	sf_goto		(void);
void	sf_1if		(void);
void	sf_2if		(void);
void	sf_3if		(void);
void	sf_label	(void);
void	sf_return	(void);
void	sf_1switch	(void);
void	sf_2switch	(void);
void	sf_1while	(void);
void	sf_2while	(void);

void	so_disable	(void);
void	so_entry	(void);
void	so_ftag		(void);
void	so_1exit	(void);
void	so_2exit	(bool ret_exp_flag);
void	so_3exit	(void);
void	so_leave	(void);

#endif /* SPPsem_h_ */
