/*
	SPP: extra time and date library.
	
	Source:  SPPtime.c
	Started: February 14, 1991.
	Version: March 16, 1996.
*/

#include "SPP.h"

#include "SPPtime.h"

#include <LIBcvt.h>
#include <string.h>

static char *monthname[] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};

static char	date_buf [30];
static char	time_buf [30];

/*
	Return the print string of the current date.
	
	See section 3.8.8 of the ANSI standard for a specification of the format.
*/
char *
the_date(void)
{
	time_t		ltime;
	struct tm *	t;
	char buffer [200]
	
	SL_DISABLE();
	
	time(&ltime);	
	t = localtime(&ltime);
	
	strcpy(date_buf, "\"");
	strcat(date_buf, cvt_trunc(buffer, 200, monthname[t -> tm_mon], 3));
	strcat(date_buf, " ");
	if (t -> tm_mday < 10) {
		strcat(date_buf, " ");
	}
	strcat(date_buf, cvt_int(buffer, 200, t -> tm_mday));
	strcat(date_buf, " ");
	strcat(date_buf, cvt_int(buffer, 200, 1900 + t -> tm_year));
	strcat(date_buf, "\"");
	
	TRACEPN("the_date", eret(); es(date_buf); enl());
	
	return date_buf;
}

/*
	Return a print string of the current time.
*/
char *
the_time(void)
{
	time_t		ltime;
	struct tm *	t;
	char buffer [200];
	
	SL_DISABLE();

	time(&ltime);	
	t = localtime(&ltime);
	
	strcpy(time_buf, "\"");
	if (t -> tm_hour < 10) {
		strcat(time_buf, "0");
	}
	strcat(time_buf, cvt_int(buffer, 200, t -> tm_hour));
	strcat(time_buf, ":");
	if (t -> tm_min < 10) {
		strcat(time_buf, "0");
	}
	strcat(time_buf, cvt_int(buffer, 200, t -> tm_min));
	strcat(time_buf, ":");
	if (t -> tm_sec < 10) {
		strcat(time_buf, "0");
	}
	strcat(time_buf, cvt_int(buffer, 200, t -> tm_sec));
	strcat(time_buf, "\"");
	
	TRACEPN("the_time", eret(); es(time_buf); enl());

	return time_buf;
}
